# -*- coding: utf-8 -*-
"""
Created on Mon Jul 17 09:47:24 2017

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import range
from builtins import super
from builtins import str
from builtins import object


class key(object):
    type = 'struct-key'
    
    def __init__(self, keyName):
        self.name = keyName
        self.ind = None
        self.properties = []
        
        
    def __repr__(self):
        prefix = '>' if 0 in self.properties else ''
        postfix = '<' if 1 in self.properties else '' 
        return prefix + '#' + self.name + postfix

        
    def __str__(self):
        prefix = '>' if 0 in self.properties else ''
        postfix = '<' if 1 in self.properties else '' 
        return prefix + '#' + self.name + postfix
        
        
    def duplicate(self):
        dupKey = key(self.name, registerKey = False)
        dupKey.ind = self.ind
        return dupKey
        
    @staticmethod
    def createKey(name, i):
        k = key(name)
        k.ind = i
        i.key = k
        return k
                
    def setIndividual(self, i):
        self.ind = i
        i.key = self
        
    def addProperty(self, prop):
        if isinstance(prop, list):
            self.properties += prop
        else:
            self.properties.append(prop)

"""

class key(object):
    keyReg = {}
    type = 'struct-key'
    
    def __init__(self, base, offset, registerKey = True):
        self.base = base
        self.offset = offset
        if registerKey:
            self.keyReg[base+'-'+str(offset)] = self
        self.ind = None
        self.properties = []
        
    def __repr__(self):
        prefix = '>' if 0 in self.properties else ''
        postfix = '<' if 1 in self.properties else '' 
        return prefix + self.base+'-'+str(self.offset) + postfix

        
    def __str__(self):
        prefix = '>' if 0 in self.properties else ''
        postfix = '<' if 1 in self.properties else '' 
        return prefix + self.base+'-'+str(self.offset) + postfix
        
    @staticmethod
    def existingKey(base, offset, ind):
        st = base+'-'+str(offset)
        if st in key.keyReg:
            if key.keyReg[st].ind != ind:
                raise ValueError('Tag name '+st+' already exists')
            return True
        return False
        

    @staticmethod
    def retrieveKey(base, offset):
        s = base+'-'+str(offset)
        if s in key.keyReg:
            return key.keyReg[s].duplicate()
        return None
        
    def duplicate(self):
        dupKey = key(self.base, self.offset, registerKey = False)
        dupKey.ind = self.ind
        return dupKey
        
    @staticmethod
    def createKey(offset, i):
        k = key(i.sort.baseSort().name, offset)
        k.ind = i
        i.key = k
        return k
        
    def setIndividual(self, i):
        self.ind = i
        i.key = self
        
    def addProperty(self, prop):
        if isinstance(prop, list):
            self.properties += prop
        else:
            self.properties.append(prop)
"""
        
        
    